﻿using System;
using System.Diagnostics;
using AopDemo.Model.Extensions;
using PostSharp.Aspects;

namespace AopDemo.Model.Attributes
{
    [Serializable]
    [DebuggerStepThrough]
    [AttributeUsage(AttributeTargets.Method | AttributeTargets.Class)]
    public sealed class CheckParametersAttribute : OnMethodBoundaryAspect {
        public override void OnEntry(MethodExecutionArgs eventArgs)
        {
            var parameters = eventArgs.Method.GetParameters();
            var arguments = eventArgs.Arguments;

            for (var i = 0; i < parameters.Length; i++) {
                foreach (var attributes in parameters[i].GetAttributes<ParameterAttribute>()) {
                    attributes.CheckParameter(parameters[i], arguments[i]);
                }
            }

            base.OnEntry(eventArgs);
        }
    }
}
